package com.example.switchyard.switchyard_example;

import javax.inject.Named;

import org.apache.camel.component.netty.NettyConsumer;
import org.apache.camel.component.netty.ServerPipelineFactory;
import org.jboss.netty.channel.ChannelPipeline;
import org.jboss.netty.channel.Channels;
import org.jboss.netty.handler.codec.frame.DelimiterBasedFrameDecoder;
import org.jboss.netty.handler.codec.frame.Delimiters;
import org.jboss.netty.handler.codec.string.StringDecoder;
import org.jboss.netty.handler.codec.string.StringEncoder;
import org.jboss.netty.util.CharsetUtil;


@Named("spf")
public class SampleServerChannelPipelineFactory extends ServerPipelineFactory {
    private int maxLineSize = 1024;

    SampleServerChannelPipelineFactory factory;
    NettyConsumer consumer;
    
    public SampleServerChannelPipelineFactory(NettyConsumer consumer)
    {
    	this.consumer = consumer;
    	
    }
    public ChannelPipeline getPipeline() throws Exception {
        ChannelPipeline channelPipeline = Channels.pipeline();

        channelPipeline.addLast("encoder-SD", new StringEncoder(CharsetUtil.UTF_8));
        channelPipeline.addLast("decoder-DELIM", new DelimiterBasedFrameDecoder(maxLineSize, true, Delimiters.lineDelimiter()));
        channelPipeline.addLast("decoder-SD", new StringDecoder(CharsetUtil.UTF_8));
        // here we add the default Camel ServerChannelHandler for the consumer, to allow Camel to route the message etc.
        channelPipeline.addLast("handler", new MyServerHandler(consumer));

        return channelPipeline;
    }

	@Override
	public ServerPipelineFactory createPipelineFactory(NettyConsumer consumer) {
		if( factory == null)
			factory = new SampleServerChannelPipelineFactory(consumer);
		return factory;
	}
}
